/*
 * corn.c: function definition for the corn library
 *
 * Copyright 2013 by Jerry Nettrouer II
 *
 * This file is part of the corn package.
 *
 * Permission to use, copy, modify, and distribute this software for any
 * purpose and without fee is hereby granted, provided
 * that the above copyright notice and this permission notice appear
 * in all copies, and that the name of Jerry Nettrouer II not be used in
 * advertising or publicity pertaining to distribution of the document
 * or software without specific, written prior permission.
 *
 * Jerry Nettrouer II makes no representations about the suitability of the
 * software described herein for any purpose.  It is provided "as is"
 * without express or implied warranty.
 *
 * The author may be contacted via http://www.inpito.org/
 * Jerry Nettrouer <j2[at]inpito.org>
 */

#include <stdio.h>

// Defining the corn function using big numbers
unsigned long int corn( unsigned long int max )
{
	// Initailize the number stuff
	int loop, size = 6;	/* size needs set to 4 on 32-Bit but can be 6 on 64-Bit systems */
	unsigned long int output, random_number;

	// Initailize the read in character string
	char line[size];

	// Initailize the arrays to hold the ascii number representations
	char small_number[2] = "";
	char large_number[13] = "";

	// Open the /dev/urandom to read in a few characters
	FILE * fp;
	fp = fopen("/dev/urandom", "r");
	fread( line, 1, size, fp );
	fclose(fp);

	// Loop through the charaters to build a number string
	for ( loop = 0; loop < size; loop++ )
	{
		// Convert the characters to an ascii number representation omitting the 3rd place
		sprintf( small_number, "%02d", abs ( line[loop] ) );

		// Append the number representations together
		sprintf( large_number, "%s%s", large_number, small_number );
	}

	// Turn the number representation into a real number
	random_number = abs( atoi ( large_number ) );

	// Delimit the number to within max number range
	output = random_number % ( max + 1);

	// output the result !
	return output;
}
